#!/usr/bin/python

from Adafruit_PWM_Servo_Driver import PWM
import time
import curses

# Initialise the PWM device 

try:
	pwm0 = PWM(0x40, debug=True)
	pwm1 = PWM(0x41, debug=True)
	pwm2 = PWM(0x42, debug=True)
	pwm3 = PWM(0x43, debug=True)

except:
	exit()

# Set frequency to 60 Hz

pwm0.setPWMFreq(50)						
pwm1.setPWMFreq(50)
pwm2.setPWMFreq(50)
pwm3.setPWMFreq(50)

# Creation de la table d'acces aux servos

tabServo = []
tabPWM = [pwm0, pwm1]

for i in range(2):
	for j in range (16):
		tabServo.append([tabPWM[i], j])

for i in range (15):
	tabServo.append([pwm2, i])
	
tabServo.append([pwm3, 0])
tabServo.append([pwm3, 1])

tabMinMax = []

with open ("gamme.txt", 'r') as base:
	for ligne in base:
		ligne = ligne.rstrip('\n\r').split(",")
		for i in range(3):
			ligne[i] = int(ligne[i])
		tabMinMax.append(ligne)
#

tps = 0.2

def play_note (n):

		tabServo[n][0].setPWM(tabServo[n][1], 0, tabMinMax[n][1])
		time.sleep(tps)
		tabServo[n][0].setPWM(tabServo[n][1], 0, tabMinMax[n][2])
#		time.sleep(tps)


def initialisation ():

	for n in range(46):

		tabServo[n][0].setPWM(tabServo[n][1], 0, tabMinMax[n][2])


def ga (i):
	for i in range (i):
		play_note(i)
		#time.sleep(0.2)

def main():

	# initialisation curses
	stdscr = curses.initscr()
	curses.noecho()
	curses.cbreak()
	stdscr.keypad(1)

	pad = curses.newpad(100, 10)
	stdscr.nodelay(1)
	count = 0

	while True:

		c = stdscr.getch()
		stdscr.addstr("""\n Touche (<:>): {0} \n Position haute (4:1): {1}  \n Position basse (^:v): {2} \n Spacebar to play and save \n (q)uit  """.format(str(count), tabMinMax[count][2], tabMinMax[count][1]))
		stdscr.move(0, 0)

		if (count >= 1 and c == curses.KEY_LEFT):
			count -= 1
			refreshScreen(pad)

		if (count < len(tabMinMax)-1 and c == curses.KEY_RIGHT):
			count += 1
			refreshScreen(pad)

		if (c == ord('4')):
			tabMinMax[count][2] += 1
			refreshScreen(pad)

		if (c == ord('1')):
			tabMinMax[count][2] -= 1
			refreshScreen(pad)

		if (c == curses.KEY_UP):
			tabMinMax[count][1] += 1
			refreshScreen(pad)

		if (c == curses.KEY_DOWN):
			tabMinMax[count][1] -= 1
			refreshScreen(pad)

		if (c == ord(' ')):
			play_note(count)
			save(tabMinMax)

		if (c == ord('q')):
			curses.nocbreak()
			stdscr.keypad(0)
			curses.echo()
			curses.endwin()
	
			break

def refreshScreen(pad):
	pad.refresh(0,0, 0,0, 10,20)

def save(tab):

	with open ("gamme.txt", 'w') as base:

		for item in tab:
			base.write("{0}, {1}, {2}\n".format(item[0], item[1], item[2]))

if __name__ == '__main__':
	main()
