#!/usr/bin/env python
# -*- coding: utf8 -*-

# WikikIRC est un petit script qui récupère le flux IRC du canal fr.wikipedia pour en faire des fichiers txt
# afin qu'ils soient lus et traduits en "MIDI" par Puredata via OSC.

# WikikIRC a été pondu par Olivier Baudu et Anthony Templier pour le Labomedia en septembre 2011.
# Modifié par Sylvain Blocquaux en 2012
# olivier arobase labomedia point net // http://lamomedia.net
# Publié sous license GPLv3 (http://www.gnu.org/licenses/gpl-3.0.html)

import irclib.irclib as irclib
import irclib.ircbot as ircbot

import urllib2
import threading
import re

import time 

debut = time.strftime('%d/%m/%y %H:%M',time.localtime())  

n = 0
m = 0

dico = {'a':0,  'b':1,  'c':2,  'd':3,  'e':4,  'f':5,
        'g':6,  'h':7,  'i':8,  'j':9,  'k':10, 'l':11,
        'm':12, 'n':13, 'o':14, 'p':15, 'q':16, 'r':17,
        's':18, 't':19, 'u':20, 'v':21, 'w':22, 'x':23,
        'y':24, 'z':25, '0':33, '1':34, '2':35, '3':36,
        '4':37, '5':38, '6':39, '7':40, '8':41, '9':42}



dicout = ('[', ']', '{', '}', '/', '*', '=', '|', '\'')


def thread_notes (diff):
    thread = threading.Thread(target=play_several_notes, args=(diff))
    thread.start()


class WikiBot(ircbot.SingleServerIRCBot):

    def __init__(self):
        
        # paramètres de connexion IRC
        ircbot.SingleServerIRCBot.__init__(self, [("irc.wikimedia.org", 6667)], "Sonification_Wikipedia", "Bot d'analyse syntaxique réalisé en Python avec ircbot")
        
        # filtre pour virer les codes couleurs et ne récupérer que le texte    
        self.filtre = re.compile( "\x03[0-9]{0,2}" )

    def on_welcome(self, serv, ev):
        
        # connexion au canal IRC
        print ("Connexion en cours sur le canal IRC ...")
        serv.join("#fr.wikipedia")

    def on_pubmsg(self, serv, ev):
        
        global n, m

        message = ev.arguments()[0] # récupère les nouveaux messages
        messageIRC = self.filtre.sub('', message) # filtre les nouveaux messages

        print ('--############################--\n')
        print ('Start at: ' + debut)
        print ('Now: ' + time.strftime('%d/%m/%y %H:%M',time.localtime())+'\n')
        print ('Message IRC numero: ' + str(m))
        print (messageIRC + '\n')
        m += 1

        positionAdresse = re.search("http://fr.wikipedia.org", messageIRC)

        if positionAdresse != None :
            adresse = messageIRC[positionAdresse.start(0):]
            tab = re.split('&', adresse)
            adresse = tab[0]
            req = urllib2.Request(adresse)
            req.add_header('User-agent', '''Mozilla/5.0 (X11; Linux i686; rv:19.0) Gecko/20100101 Firefox/19.0''') # Ajout d'un header pour faire croire à wikipedia qu'il s'agit d'un navigateur
            diff = ''
            # print (adresse)
            for ligne in urllib2.urlopen(req) :
                if 'diff-addedline' in ligne :
                    if 'diffchange-inline' in ligne : # Modification
                        while 'diffchange-inline' in ligne :
                            pos = re.search('diffchange-inline', ligne)
                            ligne = ligne[pos.start(0) + 19:] # Retire le ...<span class="diffchange diffchange-inline">
                            pos = re.search('</span>', ligne)
                            diff += ligne[0:pos.start(0)]
                    else : # Simple ajout
                        while 'diff-addedline' in ligne :
                            pos = re.search('diff-addedline', ligne)
                            ligne = ligne[pos.start(0) + 21:] # Retire le ...<td class="diff-addedline"><div>
                            pos = re.search('</div>', ligne)
                            if pos != None : # Vérifie que ce n'est pas une ligne vide
                                diff += ligne[0:pos.start(0)]


            # Affichage écran
            toScreen = diff
            for i in dicout :
                toScreen = toScreen.replace (i, ' ')
            toScreen = ' '.join(toScreen.split())
            
            # Flux traité
            diff = re.sub(r'[_,.;:^\W]', '', diff)
            diff.lstrip()
            diff = diff.lower()
		
            #if (diff != '') :
            if (diff != ''): # and (GPIO.input(17) == GPIO.HIGH)) :
                n += 1
                # affiche le message en console
                print ('---------\n')
                print ('Contenu de la modification numero: '+ str(n))
                #print (adresse)
                print (toScreen + '\n\n')
                
                #thread_notes ((diff,))

       
if __name__ == "__main__":
    # Initialisation
    #initialisation ()
    WikiBot().start()

    
